/*
/home/osboxes/opt/m68k-amigaos_30Nov18/bin/m68k-amigaos-gcc main.c -pg -O0 -Wall -noixemul -o test && sync
# execute on WinUAE Amiga A1200, approx. speed of A500/A1200 or cycle exact
sync && /home/osboxes/opt/m68k-amigaos_30Nov18/bin/m68k-amigaos-gprof test | gprof2dot -n0 -e0 | dot -Tpng -o output.png | mirage output.png &
*/



#include <stdio.h>


int fct_2(const char *caller)
{
	        printf("%s(): I was called from %s()\n",__FUNCTION__,caller);
		        return 0;
}

int (*fct_pointer)(const char *)=fct_2;

int fct_1(const char *caller)
{
	printf("%s(): I was called from %s()\n",__FUNCTION__,caller);
	printf("%s(): calling fct_2() via functions-pointer\n",__FUNCTION__);
        fct_pointer(__FUNCTION__);
	return 0;
}



int main(void)
{
	fct_pointer=fct_2;
	printf("%s(): calling fct_1()\n",__FUNCTION__);
	fct_1(__FUNCTION__);
	return 0;
}
